( function( $ ) {
	'use strict';
	var currency_symbol;
	function wpf_set_option( field_label, price, entered_label ) {
		price = parseFloat(price);
		if ( price == 0 ) {
			price = '';
		} else {
			price = wpf_pricing_format(price);
		}
		jQuery('.wpf_options_summary table').append('<tr><td>'+field_label+' - '+entered_label+'</td><td>'+ price + '</td></tr>');
	}
	function wpf_convert_pricing( type, base_price, option_price ) {
		option_price = parseFloat(option_price);
		if ( type == 'flate_fee' ) {
			return option_price;
		} else {
			option_price =  (option_price / 100) * base_price;
		}
		return option_price.toFixed(wpf_product_option.decimal_no);
	}
	 function wpf_number_format( number ) {
		 var thousandsSep = wpf_product_option.thousand_sep;
        var decPoint = wpf_product_option.decimal_sep;
        var decimals = wpf_product_option.decimal_no;
        number = (number + '').replace(/[^0-9+\-Ee.]/g, '')
        const n = !isFinite(+number) ? 0 : +number
        const prec = !isFinite(+decimals) ? 0 : Math.abs(decimals)
        const sep = (typeof thousandsSep === 'undefined') ? ',' : thousandsSep
        const dec = (typeof decPoint === 'undefined') ? '.' : decPoint
        let s = ''
        const toFixedFix = function (n, prec) {
          if (('' + n).indexOf('e') === -1) {
            return +(Math.round(n + 'e+' + prec) + 'e-' + prec)
          } else {
            const arr = ('' + n).split('e')
            let sig = ''
            if (+arr[1] + prec > 0) {
              sig = '+'
            }
            return (+(Math.round(+arr[0] + 'e' + sig + (+arr[1] + prec)) + 'e-' + prec)).toFixed(prec)
          }
        }
        s = (prec ? toFixedFix(n, prec).toString() : '' + Math.round(n)).split('.')
        if (s[0].length > 3) {
          s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep)
        }
        if ((s[1] || '').length < prec) {
          s[1] = s[1] || ''
          s[1] += new Array(prec - s[1].length + 1).join('0')
        }
        return s.join(dec)
      }
    function wpf_pricing_format( price ) {
        var currency_symbol = wpf_product_option.currency_symbol;
        var currency_position = wpf_product_option.currency_pos;
		price = wpf_number_format( price );
        if ( currency_position == 'left' ) {
            price = '<span class="woocommerce-Price-amount amount"><span class="woocommerce-Price-currencySymbol">'+currency_symbol+' </span>' + price+'</span>';

		} else if ( currency_position == 'right' ) {
            price = '<span class="woocommerce-Price-amount amount">'+price + '<span class="woocommerce-Price-currencySymbol">'+currency_symbol+' </span></span>';

		} else if ( currency_position == 'left_space' ) {
            price = '<span class="woocommerce-Price-amount amount"><span class="woocommerce-Price-currencySymbol">'+currency_symbol+' </span>' +' '+ price+'</span>';

		} else if ( currency_position == 'right_space' ) {
            price = '<span class="woocommerce-Price-amount amount">'+price + ' '+ '<span class="woocommerce-Price-currencySymbol">'+currency_symbol+' </span></span>';
		}
        return price;
    }
	function wpf_logical_options() {
		if ( jQuery('.wpf_prduct_addons').length > 0 ) {
			if ( jQuery('.wpf_options').find('select').length > 0 ) {
				jQuery('.wpf_options').find('select').select2();
			}
			if ( jQuery('input.wpf_date_range').length > 0 ) {
				jQuery('input.wpf_date_range').daterangepicker();
				jQuery('.input.wpf_date_range').val('');
			}
			if ( jQuery('input[name="wpf_options_array"]').length > 0 ) {
				var options = jQuery.parseJSON(jQuery('input.wpf_options_array').val());
			} else {
				return;
			}
			var logic_for = '';
			var logic = '';
			var logic_status = '';
			var logic_value = '';
			var type = '';
			var get_field = '';
			var flag = false;
			var removable_field1 = '';
			var removable_field2 = '';
			var removable_field3 = '';
			var removable_field4 = '';
			options.forEach(function( data, i ) {
				var checkboxes = [];
				if ( data.wpf_logic_status == '' || data.wpf_logic_option == '' ) {
					return;
				}
				logic_for = data.wpf_logic_option;
				flag = false;
				type = options[logic_for].wpf_rule_type;
				logic = data.wpf_logic_select;
				logic_status = data.wpf_logic_status;
				logic_value = data.wpf_logic_value;
				if ( 'text_area' == type ) {
					get_field = jQuery('textarea[name="wpf_textarea_'+logic_for+'"]').val();
					removable_field1 = jQuery('.wpf_textarea_'+i).find('textarea');
					
					removable_field2 = jQuery('.wpf_dropdown_'+i).find('select');
					removable_field3 = jQuery('.wpf_multiselect_'+i).find('select');
					removable_field4 = jQuery('.wpf_option_'+i).find('input');
				} else if ( 'dropdown' == type ) {
					get_field = jQuery('select[name="wpf_dropdown_'+logic_for+'"]').find('option:selected').attr('data-label');
					removable_field2 = jQuery('.wpf_dropdown_'+i).find('select');
					
					removable_field1 = jQuery('.wpf_textarea_'+i).find('textarea');
					removable_field3 = jQuery('.wpf_multiselect_'+i).find('select');
					removable_field4 = jQuery('.wpf_option_'+i).find('input');
				} else if ( 'multiselect' == type ) {
					get_field = jQuery('select[name="wpf_multiselect_'+logic_for+'[]"]').find('option:selected').attr('data-label');
					removable_field3 = jQuery('.wpf_multiselect_'+i).find('select');
					
					removable_field2 = jQuery('.wpf_dropdown_'+i).find('select');
					removable_field1 = jQuery('.wpf_textarea_'+i).find('textarea');
					removable_field4 = jQuery('.wpf_option_'+i).find('input');
				} else if ( 'radio' == type || 'checkboxes' == type || 'images' == type ) {
					if ( 'checkboxes' == type ) {
						jQuery('.wpf_option_'+logic_for).find('input').each(function( j ) {
							if ( jQuery(this).is(':checked') ) {
								checkboxes[j] = jQuery(this).attr('data-label');
							}
						});	
					} else {
						get_field = jQuery('.wpf_option_'+logic_for).find('input:checked').attr('data-label');
					}
					removable_field4 = jQuery('.wpf_option_'+i).find('input');
					
					removable_field2 = jQuery('.wpf_dropdown_'+i).find('select');
					removable_field1 = jQuery('.wpf_textarea_'+i).find('textarea');
					removable_field3 = jQuery('.wpf_multiselect_'+i).find('select');
				} else {
					get_field = jQuery('.wpf_option_'+logic_for).find('input').val();
					removable_field4 = jQuery('.wpf_option_'+i).find('input');
					
					removable_field2 = jQuery('.wpf_dropdown_'+i).find('select');
					removable_field1 = jQuery('.wpf_textarea_'+i).find('textarea');
					removable_field3 = jQuery('.wpf_multiselect_'+i).find('select');
				}
				if ( 'is_equal' == logic ) {
					if ( type == 'checkboxes' ) {
						if ( jQuery.inArray(logic_value, checkboxes) != -1 ) {
							flag = true;
						}
					} else {
						if ( get_field == logic_value ) {
							flag = true;
						}
					}
				} else if ( 'not_equal' == logic ) {
					if ( get_field != logic_value ) {
						flag = true;
					}
				} else if ( 'greater' == logic ) {
					if ( get_field > logic_value ) {
						flag = true;
					}
				} else if ( 'less' == logic ) {
					if ( get_field < logic_value ) {
						flag = true;
					}
				} else if ( 'greater_equal' == logic ) {
					if ( get_field >= logic_value ) {
						flag = true;
					}
				} else if ( 'less_equal' == logic ) {
					if ( get_field <= logic_value ) {
						flag = true;
					}
				} else if ( 'is_empty' == logic ) {
					if ( get_field == '' ) {
						flag = true;
					}
				} else if ( 'not_empty' == logic ) {
					if ( get_field != '' ) {
						flag = true;
					}
				}
				if ( 'hide' == logic_status ) {
					if ( flag ) {
						jQuery('.wpf_option_'+i).hide();
						removable_field1.removeAttr('required');
						removable_field2.removeAttr('required');
						removable_field3.removeAttr('required');
						removable_field4.removeAttr('required');
					} else {
						jQuery('.wpf_option_'+i).show();
						if ( 'images' == removable_field.attr('data-type') || 'multiselect' == jQuery('.wpf_option_'+i).find("select").attr('data-type') ) {
						removable_field1.removeAttr('required');
						removable_field2.removeAttr('required');
						removable_field3.removeAttr('required');
						removable_field4.removeAttr('required');
						} else {
							removable_field1.attr('required', 'required');
							removable_field2.attr('required', 'required');
							removable_field3.attr('required', 'required');
							removable_field4.attr('required', 'required');
						}
						jQuery('.wpf_option_'+i).find('input[type="text"]').val('');
						jQuery('.wpf_option_'+i).find('input[type="number"]').val('');
						jQuery('.wpf_option_'+i).find('input[type="email"]').val('');
						jQuery('.wpf_option_'+i).find('input[type="time"]').val('');
						jQuery('.wpf_option_'+i).find('input[type="date"]').val('');
						jQuery('.wpf_option_'+i).find('span.selection ul li.select2-selection__choice').remove();
						jQuery('.wpf_option_'+i).find('select option').removeAttr('selected');
						jQuery('.wpf_option_'+i).find('textarea').val('');
						jQuery('.wpf_option_'+i).find('input').prop('checked', false);
					}
				} else if ( 'show' == logic_status ) {
					if ( flag ) {
						jQuery('.wpf_option_'+i).show();
						removable_field1.attr('required', 'required');
						removable_field2.attr('required', 'required');
						removable_field3.attr('required', 'required');
						removable_field4.attr('required', 'required');
					} else {
						removable_field1.removeAttr('required');
						removable_field2.removeAttr('required');
						removable_field3.removeAttr('required');
						removable_field4.removeAttr('required');
						jQuery('.wpf_option_'+i).find('input[type="text"]').val('');
						jQuery('.wpf_option_'+i).find('input[type="number"]').val('');
						jQuery('.wpf_option_'+i).find('input[type="email"]').val('');
						jQuery('.wpf_option_'+i).find('input[type="time"]').val('');
						jQuery('.wpf_option_'+i).find('input[type="date"]').val('');
						jQuery('.wpf_option_'+i).find('span.selection ul li.select2-selection__choice').remove();
						jQuery('.wpf_option_'+i).find('select option').removeAttr('selected');
						jQuery('.wpf_option_'+i).find('textarea').val('');
						jQuery('.wpf_option_'+i).find('input').prop('checked', false);
						jQuery('.wpf_option_'+i).hide();
					}
				}
			});
		}
	}
		jQuery( document ).ready( function() {
			jQuery(document).on('click', 'button.single_add_to_cart_button', function( e ) {
				var flag = true;
				jQuery('.wpf_options').find('input').each(function() {
					if ( jQuery(this).attr('type') == 'checkbox' || jQuery(this).attr('type') == 'radio' ) {
						if ( jQuery(this).attr('required') == undefined ) {
							return false;
						}
						if ( jQuery(this).attr('required') == 'required' && jQuery(this).attr('checked') == 'checked' ) {
							return false;
						} else {
							flag = false;
						}
					} else {
						if ( jQuery(this).attr('required') == 'required' && jQuery(this).val() == '') {
							flag = false;
						}
					}
				});
				if ( !flag ) {
					e.preventDefault();
					jQuery('html, body').animate({scrollTop : 0}, 700);
					jQuery('#content').find('.woocommerce-error').remove();
					jQuery('#content').find('.woocommerce').append('<ul class="woocommerce-error" role="alert"><li>'+ wpf_product_option.choose_option_notice +'</li></ul>');
				}
			});
			var decimal_no = wpf_product_option.decimal_no;
			if ( jQuery('.wpf_options_array').length > 0 ) {
				var options = jQuery('.wpf_options_array').val();
				jQuery.parseJSON(options).forEach(function(data) {
					if ( ('yes' == data.wpf_option_required && 'images' == data.wpf_rule_type) || 'yes' == data.wpf_option_required && 'checkboxes' == data.wpf_rule_type  ) {
						jQuery('.single_add_to_cart_button').prop('disabled', true);
						return false;
					}
				});
			}
			wpf_logical_options();
			jQuery(document).on('click', 'div.wpf_thumbnail', function() {
				if ( jQuery(this).find('input').is(':radio') ) {
					jQuery(this).closest('.wpf_image').find('.wpf_thumbnail').removeClass('wpf_image_border');
				}
				if ( jQuery(this).find('input').is(':checked' )) {
					jQuery(this).addClass('wpf_image_border');
				} else {
					jQuery(this).removeClass('wpf_image_border');
				}
				jQuery(document).trigger('wpf_update_price');
			});
			jQuery(document).on('click', 'span.wpf_product_thumbnail', function() {
			if ( jQuery(this).find('input').is(':radio') ) {
				jQuery(this).closest('.wpf_product').find('img').removeClass('wpf_image_border');
			}
			if ( jQuery(this).find('input').is(':checked')) {
				jQuery(this).find('img').addClass('wpf_image_border');
			} else {
				jQuery(this).find('img').removeClass('wpf_image_border');
			}
			jQuery(document).trigger('wpf_update_price');
		});
			// radio button
			jQuery(document).on('click', '.wpf_radio_buttons', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			// checkboxes
			jQuery(document).on('click', '.wpf_checkbox_buttons', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			// dropdown
			jQuery(document).on('change', '.wpf_dropdown', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			jQuery(document).on('change', '.wpf_checkbox_buttons', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			jQuery(document).on('change', '.wpf_text_field', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			jQuery(document).on('keyup', '.wpf_textarea', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			jQuery(document).on('change', '.wpf_upload_file', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			jQuery(document).on('change', '.wpf_quatity_field', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			jQuery(document).on('change', '.wpf_price_field', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			jQuery(document).on('change', '.wpf_date', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			jQuery(document).on('change', '.wpf_time', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			jQuery(document).on('change', '.wpf_colorpicker', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			jQuery(document).on('change', '.wpf_multiselect', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			jQuery(document).on('input', '.wpf_range', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			jQuery(document).on('change', '.wpf_date_range', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			jQuery(document).on('input', '.quantity input', function() {
				jQuery(document).trigger('wpf_update_price');
			});
			// update prices
			jQuery(document).bind('wpf_update_price', function() {
				wpf_logical_options();
				jQuery('form.cart .quantity input.qty').trigger('change');
				if ( jQuery('input[name="wpf_options_array"]').length > 0 ) {
					var options = jQuery.parseJSON(jQuery('input[name="wpf_options_array"]').val());
				} else {
					return;
				}
				var tiered_price = parseFloat(jQuery('.wpf_product_disc_price').attr('data-product_disc_price'));
			var base_price = tiered_price ? parseFloat(tiered_price) : parseFloat(jQuery('.wpf_prduct_addons').attr('data-product_price'));
			var total_price = base_price;
			currency_symbol = wpf_product_option.currency_symbol;
			jQuery('.wpf_options_summary table').html(`
					<tr><th>`+wpf_product_option.th_label+`</th><th>`+wpf_product_option.th_price_label+`</th></tr>
					<tr><td>`+wpf_product_option.product_title+`</td><td class="wpf_product_disc_price" data-product_disc_price="">`+wpf_pricing_format(base_price)+`</td></tr>`);
				var price = 0;
				var entered_label = '';
				var entered_price = 0;
				var entered_qty = 0;
				var field_label = '';
				var type = '';
				var text_pricing = '';
				var set_date = '';
				var required = '';
				var multi_allow = '';
				var checkboxes_checked = true;
				var images_checked = true;
				options.forEach( function( data, i ) {
					field_label = data.wpf_option_label;
					price = data.wpf_options_price ? data.wpf_options_price : 0;
					type = data.wpf_option_pricing_type;
					price = parseFloat(price);
					required = data.wpf_option_required;
					multi_allow = data.wpf_option_allow_multiple;
					if ( data.wpf_rule_type == 'checkboxes' ) {
						if ( data.wpf_multi_options_label == '' ) {
							return true;
						}
						jQuery('.wpf_checkbox_'+i+' input').each(function() {
							if ( jQuery(this).is(':checked')) {
								jQuery('.wpf_checkbox_'+i).find('input').removeAttr('required');
								entered_price = jQuery(this).attr('data-price');
								entered_label = jQuery(this).attr('data-label');
								type = jQuery(this).attr('data-type');
								if ( entered_price !== undefined && entered_label !== undefined ) {
									price = wpf_convert_pricing(type, base_price, entered_price);
									wpf_set_option(field_label, price, entered_label);
									total_price += parseFloat(price);
								}
								if ( required == 'yes' && jQuery('.wpf_checkbox_'+i).find('input:checked').length < 1 ) {
									checkboxes_checked = false;
								} else {
									checkboxes_checked = true;
								}
							} else {
								if ( required == 'yes' && jQuery('.wpf_checkbox_'+i).find('input:checked').length < 1 ) {
									checkboxes_checked = false;
								} else {
									checkboxes_checked = true;
								}
							}
						});
					} else if ( data.wpf_rule_type == 'radio' ) {
						if ( data.wpf_multi_options_label == '' ) {
							return true;
						}
						jQuery('.wpf_radio_'+i).each(function(){
							entered_price = jQuery(this).find('input:checked').attr('data-price');
							entered_label = jQuery(this).find('input:checked').attr('data-label');
							type = jQuery(this).find('input:checked').attr('data-type');
							if ( entered_price == '' ) {
								return true;
							}
							if ( entered_price !== undefined && entered_label !== undefined ) {
								price = wpf_convert_pricing(type, base_price, entered_price);
								wpf_set_option(field_label, price, entered_label);
								total_price += parseFloat(price);
								return false;
							}
						});
					} else if ( data.wpf_rule_type == 'text_field' ) {
						jQuery('.wpf_text_field_'+i).each(function() {
							entered_label = jQuery(this).find('input').val();
							if ( entered_label !== '' && entered_label !== undefined ) {
								price = wpf_convert_pricing(type, base_price, price);
								wpf_set_option(field_label, price, entered_label);
								total_price += price;
							}
						});
					} else if ( data.wpf_rule_type == 'file' ) {
						jQuery('.wpf_file_'+i).each(function() {
							if ( jQuery(this).find('input').val() != '' ) {
								price = wpf_convert_pricing(type, base_price, price);
								wpf_set_option(field_label, price, jQuery(this).find('input').get(0).files[0].name);
								total_price += price;
							}
						});
					} else if ( data.wpf_rule_type == 'text_area' ) {
						jQuery('.wpf_textarea_'+i).each(function() {
							entered_label = jQuery(this).find('textarea').val();
							if ( entered_label !== '' && entered_label !== undefined ) {
								text_pricing = data.wpf_option_text_pricing;
								if ( text_pricing == 'per_char' ) {
									price = (entered_label.length * price);
								} else if ( text_pricing == 'per_word' ) {
									price = (entered_label.split(' ').length * price);
								}
								price = wpf_convert_pricing(type, base_price, price);
								wpf_set_option(field_label, price, entered_label);
								total_price += parseFloat(price);
							}
						});
					} else if ( data.wpf_rule_type == 'price' ) {
						jQuery('.wpf_price_'+i).each(function() {
							entered_price = jQuery(this).find('input').val();
							if( entered_price !== '' && entered_price != undefined ) {
								wpf_set_option(field_label, entered_price, entered_price);
								total_price += parseFloat(entered_price);
							}
						});
					} else if ( data.wpf_rule_type == 'quantity' ) {
						jQuery('.wpf_quantity_'+i).each(function() {
							entered_qty = jQuery(this).find('input').val();
							if( entered_qty !== '' && entered_qty !== undefined ) {
								price = wpf_convert_pricing(type, base_price, price);
								price *= entered_qty;
								wpf_set_option(field_label, price, entered_qty);
								total_price += price;
							}
						});
					} else if ( data.wpf_rule_type == 'heading' ) {
					} else if ( data.wpf_rule_type == 'dropdown' ) {
						if ( data.wpf_multi_options_label == '' ) {
							return true;
						}
						jQuery('.wpf_dropdown_'+i).each(function() {
							var entered_price = jQuery('option:selected', this).attr('data-price');
							var entered_label = jQuery('option:selected', this).attr('data-label');
							var type = jQuery('option:selected', this).attr('data-type');
							if ( entered_price == '' ) {
								return true;
							}
							if ( entered_price !== undefined && entered_label !== undefined ) {
								price = wpf_convert_pricing(type, base_price, entered_price);
								wpf_set_option(field_label, price, entered_label);
								total_price += parseFloat(price);
								return false;
							}
						});
					} else if ( data.wpf_rule_type == 'images' ) {
						if ( data.wpf_multi_options_label == '' ) {
							return true;
						}
						jQuery('.wpf_image_'+i).each(function() {
							// if multi allow
							if ( multi_allow == 'yes' ) {
								jQuery(this).find('input').each(function() {
									if ( jQuery(this).is(':checked')) {
										jQuery('.wpf_image_'+i).find('input').removeAttr('required');
										entered_price = jQuery(this).attr('data-price');
										entered_label = jQuery(this).closest('div.wpf_thumbnail').attr('data-label');
										type = jQuery(this).attr('data-type');
										if ( entered_price !== undefined && entered_label !== undefined ) {
											price = wpf_convert_pricing(type, base_price, entered_price);
											wpf_set_option(field_label, price, entered_label);
											total_price += parseFloat(price);
											if ( required == 'yes' && jQuery('.wpf_image_'+i).find('input:checked').length < 1 ) {
												images_checked = false;
											} else {
												images_checked = true;
											}
										}
									} else {
										if ( required == 'yes' && jQuery('.wpf_image_'+i).find('input:checked').length < 1 ) {
											images_checked = false;
										} else {
											images_checked = true;
										}
									}
								});
							} else {
								jQuery(this).find('input').each(function() {
									if ( jQuery(this).is(':checked') ) {
										entered_price = jQuery(this).attr('data-price');
										entered_label = jQuery(this).closest('div').attr('data-label');
										type = jQuery(this).attr('data-type');
										if ( entered_price == '' ) {
											return true;
										}
										if ( entered_price !== undefined && entered_label !== undefined ) {
											price = wpf_convert_pricing(type, base_price, entered_price);
											wpf_set_option(field_label, price, entered_label);
											total_price += parseFloat(price);
											return false;
										}
										if ( required == 'yes' && jQuery('.wpf_image_'+i).find('input:checked').length < 1 ) {
											images_checked = false;
										} else{
											images_checked = true;
										}
									} else {
										if ( required == 'yes' && jQuery('.wpf_image_'+i).find('input:checked').length < 1 ) {
											images_checked = false;
										} else {
											images_checked = true;
										}
									}
								});
							}
						});
					} else if ( data.wpf_rule_type == 'composite_products' ) {
					jQuery('.wpf_product_'+i).each(function() {
						jQuery(this).find('input').each(function() {
							if ( jQuery(this).is(':checked')) {
								jQuery('.wpf_product_'+i).find('input').removeAttr('required');
								entered_price = parseFloat(jQuery(this).attr('data-price'));
								entered_label = jQuery(this).closest('span.wpf_product_thumbnail').attr('data-label');
								if ( entered_price !== undefined && entered_label !== undefined ) {
									price = wpf_convert_pricing('flate_fee', base_price, entered_price);
									wpf_set_option(field_label, price, entered_label, 'yes');
									total_price += parseFloat(price);
								}
							}
						});
					});
					if ( 'yes' == required && jQuery('.pow_product_'+i).find('input:checked').length < 1 && !jQuery('.pow_product_'+i).hasClass('pow_hidden') ) {
						jQuery('.pow_product_'+i).find('input').attr('required', 'required');
					}
				} else if ( data.wpf_rule_type == 'multiselect' ) {
						jQuery('.wpf_multiselect_'+i).each(function() {
							entered_label = [];
							type = [];
							entered_price = [];
							entered_label = jQuery(this).find('option:selected').map(function() {
								return jQuery(this).data('label');
							  }).get();
							  type = jQuery(this).find('option:selected').map(function() {
								return jQuery(this).data('type');
							  }).get();
							  entered_price = jQuery(this).find('option:selected').map(function() {
								return jQuery(this).attr('data-price');
							  }).get();
							for ( var j = 0; j < entered_price.length; j++ ) {
								price = wpf_convert_pricing(type[j], base_price, entered_price[j]);
								wpf_set_option(field_label, price, entered_label[j]);
								total_price += parseFloat(price);
							}
						});
					} else if ( data.wpf_rule_type == 'date' ) {
						jQuery('.wpf_date_'+i).each(function() {
							set_date = jQuery(this).find('input').val();
							if( set_date !== '' && set_date !== undefined ) {
								price = wpf_convert_pricing(type, base_price, price);
								price = parseFloat(price);
								wpf_set_option(field_label, price, set_date);
								total_price += price;
							}
						});
					} else if ( data.wpf_rule_type == 'time' ) {
						jQuery('.wpf_time_'+i).each(function() {
							entered_qty = jQuery(this).find('input').val();
							if( entered_qty !== '' && entered_qty !== undefined ) {
								price = wpf_convert_pricing(type, base_price, price);
								wpf_set_option(field_label, price, entered_qty);
								total_price += price;
							}
						});
					} else if ( data.wpf_rule_type == 'colorpicker' ) {
						jQuery('.wpf_colorpicker_'+i).each(function() {
							entered_qty = jQuery(this).find('input').val();
							if( entered_qty !== '' && entered_qty !== undefined ) {
								price = wpf_convert_pricing(type, base_price, price);
								wpf_set_option(field_label, price, entered_qty);
								total_price += price;
							}
						});
					} else if ( data.wpf_rule_type == 'range_picker' ) {
						jQuery('.wpf_range_'+i).each(function() {
							entered_qty = jQuery(this).find('input').val();
							if( entered_qty !== '' && entered_qty !== undefined ) {
								price = wpf_convert_pricing(type, base_price, price);
								price *= entered_qty;
								wpf_set_option(field_label, price, entered_qty);
								total_price += price;
							}
						});
					} else if ( data.wpf_rule_type == 'date_range_picker' ) {
						jQuery('.wpf_date_range_'+i).each(function() {
							set_date = jQuery(this).find('input').val();
							if( set_date !== '' && set_date !== undefined ) {
								price = wpf_convert_pricing(type, base_price, price);
								wpf_set_option(field_label, price, set_date);
								total_price += price;
							}
						});
					}
				});
				console.log(' im '+images_checked+ ' chk '+checkboxes_checked);
				if ( images_checked && checkboxes_checked ) {
					jQuery('button.single_add_to_cart_button').prop('disabled', false);
				} else {
					jQuery('button.single_add_to_cart_button').prop('disabled', true);
				}
				total_price = parseFloat(total_price);
				total_price = wpf_pricing_format(total_price.toFixed(decimal_no));
				jQuery('.wpf_options_summary table').append('<tr><td>'+wpf_product_option.total_price_label+'</td><td>'+total_price+'</td></tr>');
			});
			jQuery(document).on( 'found_variation', 'form.cart', function( event, variation ) {
				jQuery('.wpf_loader').show();
				var data = {
					action : 'wpf_variation_options',
					product_id : variation.variation_id,
					nonce : wpf_product_option.nonce,
				};
				jQuery.post(wpf_product_option.ajaxurl, data, function( response ) {
					if ( response.success ) {
						jQuery('.wpf_variation_addon').html(response.data);
						jQuery('.wpf_prduct_addons').attr('data-product_price', variation.display_price);
						wpf_logical_options();
					}
					jQuery('.wpf_loader').hide();
				});
				jQuery(document).trigger('wpf_update_price');
			});
			jQuery( '.variations_form' ).on( 'woocommerce_variation_select_change', function() {
				jQuery('.wpf_variation_addon').html('');
				jQuery(document).trigger('wpf_update_price');
			});
		});
	})(jQuery);